<!-- STEP READ/WRITE -->
<section class="col-xs-12 clearfix">

  <!-- Contract Info CONTRACT_Interact_CTA -->
  <span class="form-group">
    <h4 translate="CONTRACT_Interact_Title">Read / Write Contract </h4>
    <div class="btn-group">
      <a class="btn btn-default" ng-click="dropdownContracts = !dropdownContracts">
      {{contract.selectedFunc==null ? "Select a function" : contract.selectedFunc.name}}<i class="caret"></i></a>
      <ul class="dropdown-menu" ng-show="dropdownContracts">
        <li ng-repeat="func in contract.functions track by $index"><a ng-click="selectFunc($index)">{{func.name}}</a></li>
      </ul>
    </div>
  </span>


  <!-- Write -->
  <span class="form-group" ng-show="contract.selectedFunc!=null">
    <div ng-repeat="input in contract.functions[contract.selectedFunc.index].inputs track by $index">
      <div ng-switch on="input.type">
          <div class="item write-address" ng-switch-when="address">
          <label> {{input.name}} <small> {{input.type}} </small> </label>
          <div class="row">
            <div class="col-xs-11"><input class="form-control" type="text" placeholder="0x314156..." ng-model="input.value" ng-class="Validator.isValidAddress(input.value) ? 'is-valid' : 'is-invalid'"/></div>
            <div class="col-xs-1"><div class="addressIdenticon med" title="Address Indenticon" blockie-address="{{input.value}}" watch-var="input.value" ></div></div>
          </div>
          </div>
          <p class="item write-unit256" ng-switch-when="uint256">
            <label> {{input.name}} <small> {{input.type}} </small> </label>
            <input class="form-control" type="text" placeholder="151" ng-model="input.value" ng-class="Validator.isPositiveNumber(input.value) ? 'is-valid' : 'is-invalid'"/>
          </p>
          <p class="item write-string" ng-switch-when="string">
            <label> {{input.name}} <small> {{input.type}} </small> </label>
            <input class="form-control" type="text" placeholder="Ohh! Shiny!" ng-model="input.value" ng-class="input.value!='' ? 'is-valid' : 'is-invalid'"/>
          </p>
          <p class="item write-bytes" ng-switch-when="bytes">
            <label> {{input.name}} <small> {{input.type}} </small> </label>
            <input class="form-control" type="text" placeholder="0x151bc..." ng-model="input.value" ng-class="Validator.isValidHex(input.value) ? 'is-valid' : 'is-invalid'"/>
          </p>
          <p class="item write-boolean" ng-switch-when="bool">
            <label> {{input.name}} <small> {{input.type}} </small> </label>
            <span class="radio"><label><input ng-model="input.value" type="radio" name="optradio-{{input.name}}" ng-value="true">True</label></span>
            <span class="radio"><label><input ng-model="input.value" type="radio" name="optradio-{{input.name}}" ng-value="false">False</label></span>
          </p>
          <p class="item" ng-switch-default>
            <label> {{input.name}} <small> {{input.type}} </small> </label>
            <input class="form-control" type="text" placeholder="" ng-model="input.value" ng-class="input.value!='' ? 'is-valid' : 'is-invalid'"/>
          </p>
      </div>
    </div>
  </span>
  <!-- / Write -->


  <!-- Output -->
  <span class="form-group output well" ng-show="contract.functions[contract.selectedFunc.index].constant">
    <div ng-repeat="output in contract.functions[contract.selectedFunc.index].outputs track by $index" class="form-group">
      <div ng-switch on="output.type">
        <!-- Address -->
        <div class="item write-address" ng-switch-when="address">
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <div class="row">
            <div class="col-xs-11"><input class="form-control" type="text" placeholder="0x314156..." ng-model="output.value" readonly/></div>
            <div class="col-xs-1"><div class="addressIdenticon med" title="Address Indenticon" blockie-address="{{output.value}}" watch-var="output.value" > </div> </div>
          </div>
        </div>
        <!-- unit256 -->
        <p class="item write-unit256" ng-switch-when="uint256">
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <input class="form-control" type="text" placeholder="151" ng-model="output.value" readonly/>
        </p>
        <!-- Address -->
        <p class="item write-string" ng-switch-when="string">
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <input class="form-control" type="text" placeholder="Ohh! Shiny!" ng-model="output.value" readonly/>
        </p>
        <!-- Bytes -->
        <p class="item write-bytes" ng-switch-when="bytes">
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <input class="form-control" type="text" placeholder="0x151bc..." ng-model="output.value" readonly/>
        </p>
        <!-- Boolean -->
        <p class="item write-boolean" ng-switch-when="bool">
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <span ng-show="output.value==true" class="output-boolean-true"> <img src="images/icon-check.svg" width="16px" height="16px" /> TRUE </span>
          <span ng-show="output.value==false" class="output-boolean-false"> <img src="images/icon-x.svg" width="16px" height="16px" />  FALSE </span>
        </p>
        <!--  -->
        <p class="item" ng-switch-default>
          <label> &#8627; {{output.name}} <small> {{output.type}} </small> </label>
          <input class="form-control" type="text" placeholder="" ng-model="output.value" readonly/>
        </p>
      </div>
    </div>
  </span>
  <!-- / Output -->


</section>
